<!DOCTYPE html>
<html>

<head>
  <meta charset="UTF-8"> 
  <meta name="viewport" content="width=device-width, initial-scale=1.0">

  <!-- Meta -->
  <title>GNOME + GSoC | 2023 Project Ideas</title>
  <meta name="title" content="GNOME GSoC 2023 Project Ideas">
  <meta itemprop="name" content="GNOME GSoC 2023 Project Ideas">
  <meta name="description" content="Project ideas for Google Summer of Code 2023 with GNOME">
  <meta itemprop="description" content="Project ideas for Google Summer of Code 2023 with GNOME">

  <!-- Twitter -->
  <meta property="twitter:title" content="GNOME GSoC">
  <meta property="twitter:image" content="https://gsoc.gnome.org/card.png" />
  <meta property="twitter:description" content="Project ideas for Google Summer of Code 2023 with GNOME">

  <!-- Open Graph -->
  <meta property="og:title" content="GNOME GSoC 2023 Project Ideas">
  <meta property="og:url" content="https://gsoc.gnome.org/2023/">
  <meta property="og:description" content="Participate in Google Summer of Code with GNOME">

  <link rel="stylesheet" href="https://static.gnome.org/css/inter.css">
  <link rel="stylesheet" href="https://gsoc.gnome.org/gnome.css">
  <link rel="icon" type="image/png" href="https://gsoc.gnome.org/favicon.svg" />
  <link rel="apple-touch-icon" href="https://gsoc.gnome.org/apple-touch-icon.png" sizes="180x180">
</head>

<body>

  <div class="wrapper">
    <main aria-label="Content">
      <article class="post-item">
        <h1 class="post-item-title">GNOME Project ideas for Google Summer of Code 2023</h1>

        <p>For general information on how to get involved  with our project and participate in <a href="https://summerofcode.withgoogle.com/">Google Summer of Code</a> with <a href="https://gnome.org">GNOME</a> visit <a href="https://gsoc.gnome.org">gsoc.gnome.org</a></p>


        <p>This is the list of project ideas that the GNOME community is interested in mentoring. GSoC interns can also propose their very own project ideas. If you are interested in proposing a project idea, please file an issue in our <a href="https://gitlab.gnome.org/Teams/Engagement/internship-project-ideas">Internship Project Ideas repository.</a></p>

        <p>GSoC contributors proposing something original must engage with the community strongly before or during the application period to get feedback and guidance to improve the proposal.</p>

        <h2>Project list</h2>
        <ul>
          <li><a href="#overlay-plane-unredirection-of-client-buffers-shell">Overlay plane unredirection of client buffers in GNOME Shell</a></li>
          <li><a href="#gnome-platform-demos-for-workbench">Make GNOME platform demos for Workbench</a></li>
          <li><a href="#add-acrostic-puzzels-to-gnome-crosswords">Add Acrostic Puzzles to GNOME Crosswords</a></li>
          <li><a href="#backlog-search-in-polari">Implement backlog search in Polari IRC client</a></li>
          <li><a href="#openqa-desktop-search">OpenQA testing for desktop search</a></li>
          <li><a href="#rewrite-bustle">Rewrite Bustle to Rust & GTK 4</a></li>
          <li><a href="#flatpak-sync-between-machines">Flatpak synching between machines</a></li>
          <li><a href="#create-system-settings-panel">Create a New "System" panel in GNOME Settings</a></li>
          <li><a href="#integrate-network-displays-in-settings">Integrate GNOME Network Displays features into GNOME Settings</a></li>
          <li><a href="https://gitlab.gnome.org/Teams/Engagement/internship-project-ideas">Click here to propose a new project idea</a></li>
        </ul>

     </article>

      <article class="post-item">
        <h1 class="post-item-title" id="overlay-plane-unredirection-of-client-buffers-shell"><a href="#overlay-plane-unredirection-of-client-buffers-shell">Overlay plane unredirection of client buffers in GNOME Shell</a></h1>
          <p>Implement support in mutter (and its scene graph and compositing library Clutter) for unredirecting client buffers into DRM overlay planes. This involves calculating what elements of the scene graph are candidates for unredirection, without relying on anything other than the scene graph state itself, as well as plumbing the act of unredirecting via the relevant kernel mode setting API, as well as evaluating eventually using libraries such as libliftoff.</p>

          <p>Related GitLab issues: <a href="https://gitlab.gnome.org/GNOME/mutter/-/issues/61">GNOME/mutter#61</a></p>

          <h3>Requirements</h3>
          <ul>
            <li>Computer graphics and scene graph knowledge</li>
            <li>Excellent C skills</li>
            <li>KMS/DRM experience</li>
          </ul>

          <h3>Communication</h3>
          <p>Matrix: <a href="https://matrix.to/#/#gnome-shell:gnome.org">#gnome-shell:gnome.org</a></p>

          <h3>Mentor(s): <a href="https://gitlab.gnome.org/jadahl">Jonas Ådahl</a>, <a href="https://gitlab.gnome.org/carlosg">Carlos Garnacho</a></h3>

          <h3>Project length: 350h</h3>

          <h3>More information</h3>
        <a href="https://gitlab.gnome.org/Teams/Engagement/internship-project-ideas/-/issues/10">https://gitlab.gnome.org/Teams/Engagement/internship-project-ideas/-/issues/10</a>
      </article>

      <article class="post-item">
        <h1 class="post-item-title" id="gnome-platform-demos-for-workbench"><a href="#gnome-platform-demos-for-workbench">Make GNOME platform demos for Workbench</a></h1>
          <p><a href="https://apps.gnome.org/app/re.sonny.Workbench/">Workbench</a> is an application with a focus on teaching and experimenting with GNOME technologies.</p>

          <p>One of Workbench feature, the Library, is a collection of platform demos and examples. It currently has a limited number of entries, and I (the maintainer) have not had much time to work on adding more compared to working on the core of Workbench. The project is about adding entries covering large parts of the GNOME platform. Scope can be refined depending on the interests and availability of the intern. Some examples:</p>

          <ul>
            <li>Cover GTK4 widgets with their most commonly used signals/properties</li>
            <li>Cover libadwaita widgets with their most commonly used signals/properties</li>
            <li>Cover GNOME HIG patterns</li>
            <li>Cover most common GLib/Gio APIs</li>
            <li>Cover libportal APIs</li>
          </ul>

          <p>It is possible that some demos require minor contributions to related projects such as Workbench itself or Blueprint.</p>

          <p>How it benefits GNOME?</p>

          <ul>
            <li>Showcase GNOME platform capabilities</li>
            <li>Alternative format to lengthy/heavy tutorials and API references</li>
            <li>Quick and ready to use snippets for GNOME developers</li>
          </ul>

          <h3>Requirements</h3>

          <p>⚠️ This is not a Web project - this projects is suited for JavaScript developers but is about GNOME technologies</p>

          <ul>
            <li>Linux operating system, prefarably with GNOME (use Fedora if you're not sure)</li>
            <li>JavaScript, CSS</li>
            <li>Git</li>
            <li>Enthusiasm for design/UI/UX</li>
            <li>Interest in the GNOME platform/technologies</li>
            <li>Good communication skills</li>
          </ul>

          <p>Workbench supports Vala too – translating JavaScript examples to Vala can be part of the project if there is interest.</p>

          <p>We will be accepting multiple candidates</p>

          <h3>Communication</h3>
          <p>Matrix: <a href="https://matrix.to/#/%23workbench:gnome.org">#workbench:gnome.org</a></p>

          <h3>Mentor(s): <a href="https://gitlab.gnome.org/sonny">Sonny Piers</a>, <a href="https://gitlab.gnome.org/andyholmes">Andy Holmes</a>, <a href="https://gitlab.gnome.org/bertob">Tobias Bernard</a></h3>

          <h3>Project length: adjustable</h3>

          <h3>More information</h3>
          <ul>

          </ul>
            <li><a href="https://github.com/sonnyp/Workbench/blob/main/CONTRIBUTING.md">Get started</a></li>
            <li><a href="https://gitlab.gnome.org/Teams/Engagement/internship-project-ideas/-/issues/27">https://gitlab.gnome.org/Teams/Engagement/internship-project-ideas/-/issues/27</a></li>
          </ul>
      </article>

      <article class="post-item">
        <h1 class="post-item-title" id="add-acrostic-puzzels-to-gnome-crosswords"><a href="#add-acrostic-puzzels-to-gnome-crosswords">Add Acrostic Puzzles to GNOME Crosswords</a></h1>
          <p><a href="https://gitlab.gnome.org/jrb/crosswords">GNOME Crosswords</a> is a game that lets you play crossword and other grid-style puzzles. Acrostics are a fun type of puzzle that combines Crosswords with general puzzle solving (<a href=
"https://en.wikipedia.org/wiki/Acrostic_(puzzle)">see description on wikipedia</a>). We would like to add support for acrostic puzzles to this game.</p>

          <p>This project would start by extending a library called libipuz. This library loads and saves puzzles from the free ipuz file format. They would add support to load Acrostics from disk. Testing support will also be added.</p>

          <p>Once the files are loading, they would add support to the game itself through widget work. They'd have to write two custom widgets. First, they would write an answer widget that contains a sub grid and links styles with the main grid. Then they'd modify the clue row widget for acrostics to support the different types of clues.</p>

          <p>As a final step, a separate widget will be written to add a custom layout for acrostics. Given that acrostics behave differently than crosswords, we want to lay them out differently. This can be done either by extending the existing custom widget, or them writing their own.</p>

          <h3>Requirements</h3>
          <ul>
            <li>Knowledge of C is required. Most of the code being touched will be in C</li>
            <li>Experience with GObject / GTK / json is preferred, but not necessary for this project</li>
            <li>Enjoying solving puzzles is a bonus, but not required!</li>
          </ul>

          <h3>Communication</h3>
          <p>Chat (Matrix or WhatsApp) and email are preferred. Video call is available, but not regularly.</p>
          <p>Matrix: <a href="https://matrix.to/#/@jblandford:matrix.org">@jblandford:matrix.org</a></p>

          <h3>Mentor(s): <a href="https://gitlab.gnome.org/jrb">Jonathan Blandford</a>, <a href="https://gitlab.gnome.org/federico">Federico Mena Quintero</a></h3>

          <h3>Project length:</h3>
          <p>This could be either a Short or Long. The full time is required to finish the feature, but there is a reasonable off-ramp half-way through for partial support.</p>

          <h3>More information</h3>
        <a href="https://gitlab.gnome.org/Teams/Engagement/internship-project-ideas/-/issues/28">https://gitlab.gnome.org/Teams/Engagement/internship-project-ideas/-/issues/28</a>
      </article>

      <article class="post-item">
        <h1 class="post-item-title" id="backlog-search-in-polari"><a href="#backlog-search-in-polari">Implement backlog search frontend in Polari IRC client</a></h1>
          <p><a href="https://apps.gnome.org/app/org.gnome.Polari/">Polari</a> The Polari IRC client currently has limited capabilities to access to logs of old conversations. This project aims to finish the port of its logging infrastructure from Telepathy Logger to Tracker, in order to improve Polari search capabilities from there. Search in old conversations is a valued tool in free software IM channels, this is expected to enhance productivity when using IRC.</p>

          <h3>Requirements</h3>
          <ul>
            <li>Knowledge about GTK and JavaScript will be required.</li>
            <li>Ground knowledge about RDF and SPARQL is accessory, but welcome.</li>
          </ul>

          <h3>Communication</h3>
          <p>The #polari IRC channel at irc.gnome.org</p>

          <h3>Mentor(s): <a href="https://gitlab.gnome.org/carlosg">Carlos Garnacho</a>, <a href="https://gitlab.gnome.org/fmuellner">Florian Müllner</a></h3>

          <h3>Project length: 175h</h3>

          <h3>More information</h3>
        <a href="https://gitlab.gnome.org/Teams/Engagement/internship-project-ideas/-/issues/12">https://gitlab.gnome.org/Teams/Engagement/internship-project-ideas/-/issues/12</a>
      </article>

      <article class="post-item">
        <h1 class="post-item-title" id="openqa-desktop-search"><a href="#openqa-desktop-search">OpenQA testing for desktop search</a></h1>
          <p>OpenQA is a testing tool, we are trialling OpenQA to do <a href="https://gitlab.gnome.org/GNOME/gnome-build-meta/-/wikis/openqa/OpenQA-for-GNOME-developers">end-to-end testing of GNOME OS.</a></p>

          <p>Currently there are no tests for desktop search, this is blocked on having some well-defined example content to search through.</p>

          <p>There are three steps to make this happen, you could propose to do the first only, or the first two, or all three.</p>

          <h4>1 - Collect realistic examples of user content, and set up a CI process to build a disk image with a realistic home directory.</h4>

          <p>Requirements for this task can be found here: <a href="https://gitlab.gnome.org/GNOME/openqa-tests/-/issues/8#note_1664309">GNOME/openqa-tests#8 (comment 1664309)</a></p>
          <p>As a guide, this may be around 80 hours of work.</p>

          <h4>2 - Update OpenQA tests to mount the disk image from (1) at /home/testuser</h4>

          <p>This requires basic knowledge of QEMU. There is probably a test in the https://github.com/os-autoinst/os-autoinst-distri-opensuse/ repo that shows how to do this.
This may be 20-40 hours work, depending on experience with QEMU and OpenQA</p>

          <h4>3 - Create initial set of tests for desktop search</h4>

          <p>The idea of OpenQA testing is to have a small set of tests which cover a lot of functionality. The goal would be to find 2 or 3 search queries, which are able to exercise many difficult codepaths within the search infrastructure. We might produce many tests and select the most useful 3 from those.</p>

          <p>This might be completed to a minimal within 20 hours but ideally more time would be spent to ensure code coverage is as high as possible. (Note that actually measuring coverage may be too difficult, we might have to estimate based on reading code).</p> 

          <h3>Requirements</h3>
          <ul>
            <li>Knowledge of scripting languages, e.g. Python (for step 1) and Perl (for step 3).</li>
            <li>Basic knowledge of managing virtual machines and disk images with QEMU (for step 1 and 2).</li>
          </ul>

          <h3>Communication</h3>
          <p>TBD</p>

          <h3>Mentor(s): <a href="https://gitlab.gnome.org/sthursfield">Sam Thursfield</a>, <a href="https://gitlab.gnome.org/alatiera">Jordan Petridis </a></h3>

          <h3>Project length: 175h (extensible to Long (~350 hours) if preferred.)</h3>

          <h3>More information</h3>
        <a href="https://gitlab.gnome.org/Teams/Engagement/internship-project-ideas/-/issues/29">https://gitlab.gnome.org/Teams/Engagement/internship-project-ideas/-/issues/29</a>
      </article>
      <article class="post-item">
        <h1 class="post-item-title" id="flatpak-sync-between-machines"><a href="#flatpak-sync-between-machines">Flatpak synching between machines</a></h1>
          <p>Currently, it’s rather bothersome to sync the <a href="https://flatpak.org">Flatpak</a> packages installed on multiple systems: One either has to manually keep them in sync or use the CLI to get a list of installed Flatpaks.</p>

          <p>As such, it would be useful to have an application that can do this for users. The go-to approach would be a D-Bus daemon that automatically (either on changes or periodically) creates a list of installed Flatpaks and pushes it to a service like GitHub Gists. If a new version is detected (which comes from a different system), the daemon would fetch it and adjust the local installation accordingly.</p>

          <p>Additionally, there should be a GUI application that can interface with the daemon for setup and configuration. A CLI application for usage independent of the DE and manual syncing would be a plus.</p>

          <h3>Requirements</h3>
           <p>Since the project should be useable on Silverblue, it’d be good if the binary can run on it by default. Since Silverblue doesn’t have GJS nor Python installed by default, Rust seems like a good choice now that we have zbus.</p>
          <ul>
            <li>Familiarity with Rust & DBus</li>

          </ul>

          <h3>Communication</h3>
          <p>Matrix</p>

          <h3>Mentor(s): <a href="https://gitlab.gnome.org/Cogitri">Rasmus Thomsen</a>

          <h3>Project length: 175 hours</h3>

          <h3>More information</h3>
        <a href="https://gitlab.gnome.org/Teams/Engagement/internship-project-ideas/-/issues/34">https://gitlab.gnome.org/Teams/Engagement/internship-project-ideas/-/issues/34</a>
      </article>

      <article class="post-item">
        <h1 class="post-item-title" id="rewrite-bustle"><a href="#rewrite-bustle">Rewrite Bustle to Rust & GTK 4</a></h1>
          <p><a href="https://gitlab.freedesktop.org/bustle/bustle">Bustle</a> is a  graphical D-Bus message analyser and profiler. </p>

          <p>Bustle draws sequence diagrams of D-Bus activity, showing signal
            emissions, method calls and their corresponding returns, with timestamps
            for each individual event and the duration of each method call. This can
            help you check for unwanted D-Bus traffic, and pinpoint why your
            D-Bus-based application isn't performing as well as you like. It also
            provides statistics like signal frequencies and average method call
            times.</p>

          <p>Currently, Bustle is written in Haskell & GTK 3. Haskell bindings are not very nice to use, not that many contributors to the bindings themselves and no one is capable of updating the application on the wide GNOME community. Especially when it comes to generating a working Flatpak manifest.</p>

          <p>The idea is to rewrite it in Rust & GTK 4 using zbus for the dbus part.</p>

          <h3>Requirements</h3>
          <ul>
            <li>Familiarity with Rust & DBus</li>
          </ul>

          <h3>Communication</h3>
          <p>Matrix</p>

          <h3>Mentor(s): <a href="https://gitlab.gnome.org/bilelmoussaoui">Bilal Elmoussaoui </a>, <a href="https://gitlab.gnome.org/msandova">Maximiliano</a>, <a href="https://gitlab.gnome.org/wjt">Will Thompson</a></h3>

          <h3>Project length: 350 hours</h3>

          <h3>More information</h3>
        <a href="https://gitlab.gnome.org/Teams/Engagement/internship-project-ideas/-/issues/26">https://gitlab.gnome.org/Teams/Engagement/internship-project-ideas/-/issues/26</a>
      </article>

      <article class="post-item">
        <h1 class="post-item-title" id="integrate-network-displays-in-settings"><a href="#integrate-network-displays-in-settings">Integrate GNOME Network Displays features into GNOME Settings</a></h1>
          <p><a href="https://gitlab.gnome.org/GNOME/gnome-control-center/">GNOME Settings</a> (aka gnome-control-center) is GNOME's main interface for configuration of various aspects of your desktop.</p>

          <p><a href="https://gitlab.gnome.org/gnome/gnome-network-displays">GNOME Network Displays</a> is a standalone application for casting your display's content onto another remote display in the network.</p>

          <p>The goal of this project would be to reuse the work in gnome-network-displays to be able to manage remote displays in the GNOME Settings Display panel. Allowing users to select the remote display from the list where they already can find local displays/monitors. This work will involve iterating with the GNOME design team and discussing the UX of the functionality.</p>

          <h3>Requirements</h3>
          <ul>
            <li>Experience with C/GObject and GTK</li>
            <li>Familiarity with networking protocols</li>
          </ul>

          <h3>Communication</h3>
          <p>Matrix: <a href="https://matrix.to/#/#control-center:gnome.org">#control-center:gnome.org</a></p>

          <h3>Mentor(s): <a href="https://gitlab.gnome.org/felipeborges/">Felipe Borges</a>, <a href="https://gitlab.gnome.org/cwunder">Claudio Wunder</a>, and others</h3>

          <h3>Project length: 175h</h3>

          <h3>More information</h3>
        <a href="https://gitlab.gnome.org/Teams/Engagement/internship-project-ideas/-/issues/32">https://gitlab.gnome.org/Teams/Engagement/internship-project-ideas/-/issues/32</a>
      </article>

      <article class="post-item">
        <h1 class="post-item-title" id="create-system-settings-panel"><a href="#create-system-settings-panel">Create a New "System" panel in GNOME Settings</a></h1>
          <p><a href="https://gitlab.gnome.org/GNOME/gnome-control-center/">GNOME Settings</a> (aka gnome-control-center) is GNOME's main interface for configuration of various aspects of your desktop.</p>

          <p>We have an ongoing issue with there being too many top level settings panels (<a href="https://gitlab.gnome.org/GNOME/gnome-control-center/-/issues/1090">see #1090</a>). One way to help with this would be to move Region & Language, Date & Time, Users, and About into a new System panel (<a href="https://gitlab.gnome.org/Teams/Design/settings-mockups/-/blob/master/system/system-panel.png">mockups</a>).</p>

          <p>Previously we had the "details" panel, which served a similar function. We removed that after people seemed to get confused by it, though now I wonder whether it was as much an issue with the "details" name as much as anything else.
Other platforms have a "system" section, so I think people are used to this concept. Also, we've tested the system panel design with users, and it has performed well (see Teams/Design/usability#10).</p>

          <p>The implementation should take inspiration on the recent redesign of the <a href="https://gitlab.gnome.org/GNOME/gnome-control-center/-/merge_requests/1497">Accessibility panel</a>. For this reason, a good way to organize the codebase is:</p>

          <ul>
            <li>Move the panel sources into a new panel/system/ folder</li>
            <li>Convert each CcPanel object into a new widget that could be used as a page for the system panel (likely AdwPreferencesPage)</li>
            <li>Implement the CcSystemPanel class implementing the pagination from the designs (likely an AdwLeaflet with rows that when clicked will open each page).</li>
            <li>Identify duplicated code between the panels that can be reused/refactored</li> 
            <li>Customize each page to account for differences between panels and page (for example, widgets that a panel would place in the headerbar now could be placed elsewhere, etc...)</li>
            <li>Address design review (GNOME designers will suggest modifications. You should plan and expect design iteractions that change the original design from the mockups).</li>
          </ul>

          <h3>Requirements</h3>
          <ul>
            <li>Strong GTK and C (GLib/GObject introspection) skills</li>
            <li>Knowledge of the Linux desktop stack internals (systemd, dbus)</li>
          </ul>

          <h3>Communication</h3>
          <p>Matrix: <a href="https://matrix.to/#/#control-center:gnome.org">#control-center:gnome.org</a></p>

          <h3>Mentor(s): <a href="https://gitlab.gnome.org/felipeborges/">Felipe Borges</a>, <a href="https://gitlab.gnome.org/feaneron/">Georges Basile Stavracas Neto</a></h3>

          <h3>Project length: 350h</h3>

          <h3>More information</h3>
        <a href="https://gitlab.gnome.org/GNOME/gnome-control-center/-/issues/2241">https://gitlab.gnome.org/GNOME/gnome-control-center/-/issues/2241</a>
      </article>
    </main>
  </div>

</body>

</html>
